%
% Stammdaten (FH Wedel)
%

/***********************************************************/
/* Ausgabedateien                                          */
/***********************************************************/
/* ausgabeDatei(Datei).                                    */
/* Ausgeben des fertigen Plans in Prolog.                  */
/***********************************************************/
ausgabeDatei('Plan.pl').

/***********************************************************/
/* tag(Name, Gewichtung)                                   */
/***********************************************************/
tag('Montag', 0).
tag('Dienstag', 0).
tag('Mittwoch', 0).
tag('Donnerstag', 0).
tag('Freitag', 0).
tag('Samstag', 150).

%tageOhneMittag(['Samstag']).
%tageOhneMittag(_) :- false.

/***********************************************************/
/* zeit(Uhrzeit, Gewichtung)                               */
/***********************************************************/
zeit('8:00' , 0).
zeit('9:30' , 0).
zeit('11:00', 0).
zeit('Mittagspause', 2).
zeit('13:45', 0).
zeit('15:15', 0).
zeit('16:45', 0).
zeit('18:15', 100).

/***********************************************************/
/* mittagszeit(Uhrzeit, Uhrzeit, Uhrzeit)                  */
/***********************************************************/
mittagszeit(['11:00', 'Mittagspause', '13:45']).


/***********************************************************/
/* kolloquium(+Tag, +Zeit, +Raumname)                   */
/***********************************************************/
kolloquium('Mittwoch', '16:45', hs5).

/***********************************************************/
/* raum(Name, Groesse, [Ressourcen], Gewichtung)           */
/***********************************************************/
raum(hs1, 60, [hs1, vorlesung, beamer], 0).
raum(hs2, 200, [hs2, vorlesung, beamer], 3).
raum(hs3, 120, [hs3, vorlesung], 0).
raum(hs4, 120, [hs4, vorlesung, beamer], 0).
raum(hs5, 150, [hs5, vorlesung, hiresBeamer, beamer], 4).
raum(hs6, 200, [hs6, vorlesung, beamer], 0).

raum(sr1, 50, [sr1], 2).
raum(sr2, 15, [sr2, vorlesung], 0).
raum(sr3, 15, [sr3, vorlesung], 0).
raum(sr4, 15, [sr4, vorlesung], 0).

raum(werkstatt, 50, [werkstatt], 0).
raum(etlab, 50, [etlab], 0).
raum(bvalab, 50, [bvalab], 0).
raum(robotlab, 20, [robotlab], 0).
raum(elklab, 35, [elklab], 0).
raum(netzlab, 45, [netzlab], 0).
raum(rz1, 50, [rz1], 0).
raum(rz2, 50, [rz2], 0).
raum(rz3, 50, [rz3], 0).
raum(rz4, 35, [rz4], 0).
raum(mrz, 40, [mrz], 0).
raum(medilab, 40, [medilab], 0).
raum(caelab, 15, [caelab], 0).

/***********************************************************/
/* teilnehmer(Name, Groesse)                               */
/***********************************************************/
teilnehmer(ii1, 10).
teilnehmer(ii2, 6).
teilnehmer(ii3, 5).
teilnehmer(ii4, 6).
teilnehmer(ii5, 4).
teilnehmer(ii6, 5).
teilnehmer(ii7, 5).
teilnehmer(ii8, 6).

teilnehmer(wi1, 20).
teilnehmer(wi2, 12).
teilnehmer(wi3, 10).
teilnehmer(wi4, 11).
teilnehmer(wi5, 9).
teilnehmer(wi6, 10).
teilnehmer(wi7, 11).
%teilnehmer(wi8, 9).

teilnehmer(mi1, 25).
%teilnehmer(mi2, 12).
teilnehmer(mi3, 11).
teilnehmer(mi4, 10).
%teilnehmer(mi5, 9).
%teilnehmer(mi6, 9).
%teilnehmer(mi7, 9).
%teilnehmer(mi8, 9).

teilnehmer(di1, 20).
%teilnehmer(di2, 10).
teilnehmer(di3, 9).
%teilnehmer(di4, 8).
teilnehmer(di5, 9).
%teilnehmer(di6, 9).
%teilnehmer(di7, 9).
%teilnehmer(di8, 8).

teilnehmer(pi1, 6).
teilnehmer(pi2, 4).
teilnehmer(pi3, 5).
teilnehmer(pi4, 4).
teilnehmer(pi5, 3).
teilnehmer(pi6, 4).
teilnehmer(pi7, 4).
teilnehmer(pi8, 4).

%teilnehmer(ui1, 10).
%teilnehmer(ui2, 9).
%teilnehmer(ui3, 8).
teilnehmer(ui4, 9).

teilnehmer(ai1, 10).
%teilnehmer(ai2, 9).
teilnehmer(ai3, 8).
%teilnehmer(ai4, 8).

teilnehmer(ea1, 6).
%teilnehmer(ea2, 4).
teilnehmer(ea3, 4).
%teilnehmer(ea4, 3).
teilnehmer(ea5, 4).

teilnehmer(ia1, 10).
%teilnehmer(ia2, 7).
teilnehmer(ia3, 6).
%teilnehmer(ia4, 6).
teilnehmer(ia5, 7).

teilnehmer(pa1, 5).
%teilnehmer(pa2, 3).
teilnehmer(pa3, 4).
%teilnehmer(pa4, 3).
teilnehmer(pa5, 3).

/***********************************************************/
/* dozenten([Namen])                                       */
/***********************************************************/
dozenten([ha, si, sc, pt, klk, ahr, al, an, bew, bi, bd, cho, 
          gie, glu, hai, goe, pol, su, jac, kl, hi, kr, ue, 
          wink, hn, hs, sb, ge, br, pd, wol, sti, di, 
          wen, gla, franz, klickow, klb, krueger, op, str, 
          pk, rb, sw, sed, sm, stach, steinm, st, tern, theel, 
          wd, wal]).

/***********************************************************/
/* untergruppe(UGruppenName, OGruppenName, TName)          */
/* Festlegen der Untergruppen                              */
/* Wichtig:  Einhalten der Raumgroessen liegt beim         */
/*           Gruppenleiter                                 */
/***********************************************************/
% ps1ueb
untergruppe(wi1ps1, ps1ueb, wi1).
untergruppe(ii1ps1, ps1ueb, ii1).
untergruppe(mi1ps1, ps1ueb, mi1).
% ps2ueb
untergruppe(ia3ps2, ps2ueb, ia3).
untergruppe(wi2ps2, ps2ueb, wi2).
untergruppe(ii2ps2, ps2ueb, ii2).
untergruppe(di3ps2, ps2ueb, di3).
% unixueb
untergruppe(ia3unix, unixueb, ia3).
untergruppe(ia5unix, unixueb, ia5).
untergruppe(wi3unix, unixueb, wi3).
untergruppe(wi4unix, unixueb, wi4).
untergruppe(ii3unix, unixueb, ii3).
untergruppe(ii4unix, unixueb, ii4).
untergruppe(mi3unix, unixueb, mi3).
% oopueb
untergruppe(ia5oop, oopueb, ia5).
untergruppe(mi4oop, oopueb, mi4).
untergruppe(ii4oop, oopueb, ii4).
untergruppe(ii5oop, oopueb, ii5).
untergruppe(ii6oop, oopueb, ii6).
untergruppe(wi4oop, oopueb, wi4).
untergruppe(wi5oop, oopueb, wi5).
untergruppe(wi6oop, oopueb, wi6).

%
% Wahlbloecke fuer Studenten
%
/*
% wi Schwerpunkt Informatik/BWL
untergruppe(wiBWL_1, wahlblock_wi, wi5).
untergruppe(wiInformatik_1, wahlblock_wi, wi5).
untergruppe(wiBWL_2, wahlblock_wi, wi6).
untergruppe(wiInformatik_2, wahlblock_wi, wi6).
untergruppe(wiBWL_3, wahlblock_wi, wi7).
untergruppe(wiInformatik_3, wahlblock_wi, wi7).
% di Schwerpunkt Technologie/Informationssysteme/Umwelt
untergruppe(diTechnologie_1, wahlblock_di, di4).
untergruppe(diInformationssysteme_1, wahlblock_di, di4).
untergruppe(diUmwelt_1, wahlblock_di, di4).
untergruppe(diTechnologie_2, wahlblock_di, di5).
untergruppe(diInformationssysteme_2, wahlblock_di, di5).
untergruppe(diUmwelt_2, wahlblock_di, di5).
untergruppe(diTechnologie_3, wahlblock_di, di6).
untergruppe(diInformationssysteme_3, wahlblock_di, di6).
untergruppe(diUmwelt_3, wahlblock_di, di6).
% di Sprachen (Englisch, Franzoesisch)
untergruppe(diSprachen1, sprachen, di1).
%untergruppe(diSprachen2, sprachen, di2).
untergruppe(diSprachen3, sprachen, di3).
% ii Schwerpunkt Software/Hardware
untergruppe(iiSoftware_1, wahlblock_ii, ii4).
untergruppe(iiHardware_1, wahlblock_ii, ii4).
untergruppe(iiSoftware_2, wahlblock_ii, ii5).
untergruppe(iiHardware_2, wahlblock_ii, ii5).
untergruppe(iiSoftware_3, wahlblock_ii, ii6).
untergruppe(iiHardware_3, wahlblock_ii, ii6).
% mi Schwerpunkt Medien/Informatik/BWL
untergruppe(miMedien_1, wahlblock_mi, mi4).
untergruppe(miInformatik_1, wahlblock_mi, mi4).
untergruppe(miBWL_1, wahlblock_mi, mi4).
untergruppe(miMedien_2, wahlblock_mi, mi5).
untergruppe(miInformatik_2, wahlblock_mi, mi5).
untergruppe(miBWL_2, wahlblock_mi, mi5).
untergruppe(miMedien_3, wahlblock_mi, mi6).
untergruppe(miInformatik_3, wahlblock_mi, mi6).
untergruppe(miBWL_3, wahlblock_mi, mi6).
% pi Schwerpunkt Lasertechnik/Management/Informatik
untergruppe(piLasertechnik_1, wahlblock_pi, pi4).
untergruppe(piManagement_1, wahlblock_pi, pi4).
untergruppe(piInformatik_1, wahlblock_pi, pi4).
untergruppe(piLasertechnik_2, wahlblock_pi, pi5).
untergruppe(piManagement_2, wahlblock_pi, pi5).
untergruppe(piInformatik_2, wahlblock_pi, pi5).
untergruppe(piLasertechnik_3, wahlblock_pi, pi6).
untergruppe(piManagement_3, wahlblock_pi, pi6).
untergruppe(piInformatik_3, wahlblock_pi, pi6).
*/