<?xml version="1.0" encoding="ISO-8859-1"?>

<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html" indent="yes" />

	<xsl:variable name="teilnehmerliste" select="document('teilnehmerliste.xml')/teilnehmerliste" />

	<xsl:variable name="beschriftung-tag">#808080</xsl:variable>

	<xsl:variable name="beschriftung-sonstiges">#c0c0c0</xsl:variable>

	<xsl:variable name="beschriftung-vorlesung">#ffffff</xsl:variable>

	<xsl:variable name="beschriftung-freistunde">#f0d306</xsl:variable>

	<xsl:template match="stundenplan">
		<html>
			<head>
				<title>Stundenplan FH Wedel</title>
			</head>
			<body>
				<div align="center">
					<h1>Stundenplan FH Wedel</h1>
				</div>
				<br />
				<table border="1" cellpadding="1" cellspacing="0">
					<xsl:for-each select="tag">
						<tr>
							<th align="center" bgcolor="{$beschriftung-sonstiges}">
								Tag
							</th>
							<th align="center" bgcolor="{$beschriftung-sonstiges}">
								<xsl:text>Raum</xsl:text>
							</th>
							<xsl:apply-templates mode="ueberschrift" select="raum" />
						</tr>
						<xsl:for-each select="raum">
							<tr>
								<xsl:if test="position()=1">
									<th align="center" bgcolor="{$beschriftung-tag}">
										<xsl:attribute name="rowspan">
											<xsl:value-of select="count(../raum)" />
										</xsl:attribute>
										<xsl:value-of select="../@name" />
									</th>
								</xsl:if>
								<td align="center" bgcolor="{$beschriftung-sonstiges}">
									<b><xsl:value-of select="@name" /></b>
								</td>
								<xsl:for-each select="zeit">
									<xsl:call-template name="veranstaltung" />
								</xsl:for-each>
							</tr>
						</xsl:for-each>
					</xsl:for-each>
				</table>
				<br />
				<h2>Termin nach Absprache</h2>
				<table border="1" cellpadding="1" cellspacing="0">
					<xsl:for-each select="absprache">
						<tr>
							<xsl:call-template name="veranstaltung" />
						</tr>
					</xsl:for-each>
				</table>
			</body>
		</html>
	</xsl:template>

	<xsl:template mode="ueberschrift" match="raum">
		<xsl:if test="position()=1">
			<xsl:for-each select="zeit">
				<th align="center" bgcolor="{$beschriftung-sonstiges}">
					<xsl:value-of select="@name" />
				</th>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>

	<xsl:template name="veranstaltung">
		<xsl:choose>
			<xsl:when test="count($teilnehmerliste/teilnehmer) = 0">
				<xsl:choose>
					<xsl:when test="veranstaltung">
						<td bgcolor="{$beschriftung-vorlesung}">
							<xsl:apply-templates select="veranstaltung" />
						</td>
					</xsl:when>
					<xsl:otherwise>
						<td bgcolor="{$beschriftung-freistunde}">
							<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
						</td>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:when>
			<xsl:otherwise>
				<xsl:choose>
					<xsl:when test="count( veranstaltung/teilnehmer/@name[string() = $teilnehmerliste/teilnehmer/@name] ) > 0">
					<!-- xsl:when test="count( veranstaltung/teilnehmer/@name[string() = $teilnehmerliste/teilnehmer/@name] ) > 0" -->
						<td bgcolor="{$beschriftung-vorlesung}">
							<xsl:apply-templates select="veranstaltung" />
						</td>
					</xsl:when>
					<!-- xsl:when test="count( veranstaltung/teilnehmer/@name[contains(string(),$teilnehmerliste/teilnehmer/@name)] ) > 0">
						<td bgcolor="{$beschriftung-vorlesung}">
							<xsl:apply-templates select="veranstaltung" />
						</td>
					</xsl:when -->
					<xsl:when test="veranstaltung">
						<td bgcolor="{$beschriftung-vorlesung}">
							<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
						</td>
					</xsl:when>
					<xsl:otherwise>
						<td bgcolor="{$beschriftung-freistunde}">
							<xsl:text disable-output-escaping="yes">&amp;nbsp;</xsl:text>
						</td>
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>

	<xsl:template match="veranstaltung">
		<table>
			<tr>
				<td>
					<xsl:value-of select="@name" />
					<xsl:for-each select="teilnehmer[@dozent='true']">
						<xsl:sort select="@name" />
						<xsl:if test="position() = 1">
							<xsl:text> (</xsl:text>
						</xsl:if>
						<xsl:value-of select="@name" />
						<xsl:if test="position() != last()">
							<xsl:text>, </xsl:text>
						</xsl:if>
						<xsl:if test="position() = last()">
							<xsl:text>)</xsl:text>
						</xsl:if>
					</xsl:for-each>
				</td>
			</tr>
			<tr>
				<td>
					<xsl:for-each select="teilnehmer[not(@dozent) or @dozent='false']">
						<xsl:sort select="@name" />
						<xsl:if test="position() = 1">
							<xsl:text>[</xsl:text>
						</xsl:if>
						<xsl:value-of select="@name" />
						<xsl:if test="position() != last()">
							<xsl:text>, </xsl:text>
						</xsl:if>
						<xsl:if test="position() = last()">
							<xsl:text>]</xsl:text>
						</xsl:if>
					</xsl:for-each>
				</td>
			</tr>
		</table>
	</xsl:template>

</xsl:stylesheet>
