%
% einfacheTests.pl
%
% Durchfuehren erster Test 
% - sind in der Wissensbasis Fehler vorhanden
% 

% letzte Aenderung 7.11.01 mb: verhindere das 
% Wunsch-veranstaltungenNichtAmSelbenTag
% als normale veranstaltungenNichtAmSelbenTag getestet werden

% letzte Aenderung 15.11.01 rs: einfuegen weiterer Tests,
% veranstaltungenNichtZusammenhaengend - doppelstunde usw.

% letzte Aenderung 16.11.01 rs: neue Strukturierung der Klauseln,
% Refaktiorisierung fuer bessere Lesbarkeit und Strukturierung,
% weitere Testfaelle erweitert, weil Abfrage nicht vollstaendig.

% letzte Aenderung 16.11.01 mb: ermoegliche in findeRaumzuordnungen
% auch das und(Raeume)-Fakt fr veranstaltungsressourcen

% letzte Aenderung 4.2.02 rs: abfangen des Fehlers, wenn keine 
% Veranstaltungen, Tage, Zeiten oder Raeume angegeben wurden

/***********************************************************/
/* fuehreTestsDurch                                        */
/***********************************************************/
/* Steuerung der Tests der Wissensbasis                    */
/* Wird beim Durchlauf eines Tests ein Fehler gefunden,    */
/* endet das Programm mit einer aussagekraeftigen Fehler-  */
/* meldung.                                                */
/***********************************************************/
fuehreTestsDurch :-
	bereiteTestsVor(VeranstaltungsListe, AnzVeranstaltungen, TagListe, AnzTage, ZeitListe, AnzZeiten, RaumListe, AnzRaeume),	
	testePlatzierungsmoeglichkeiten(AnzRaeume, AnzZeiten, AnzTage, AnzVeranstaltungen),
	testeVeranstaltungsnamen(VeranstaltungsListe),
	testeVeranstaltungsverweise(VeranstaltungsListe),
	testeRaumzuteilung(RaumListe, VeranstaltungsListe),
	testeRaumzuordnungen(VeranstaltungsListe),
	testeKarteileichen,
	testeUntergruppen,
	testeZeiteinheiten(TagListe, AnzTage, AnzZeiten),
	testeHarteConstraints,
	writeln("Alle Tests erfolgreich abgeschlossen, weitere Schritte"),
	writeln("werden in Angriff genommen.").

/***********************************************************/

/***********************************************************/
/* bereiteTestsVor(+VeranstaltungsListe,                   */
/*      +AnzVeranstaltungen, +TagListe, +AnzTage,          */
/*      +ZeitListe, +AnzZeiten, +RaumListe, +AnzRaeume)    */
/***********************************************************/
/* Erstellen der benoetigten Liste                         */
/***********************************************************/
bereiteTestsVor(VeranstaltungsListe, AnzVeranstaltungen, TagListe, AnzTage, ZeitListe, AnzZeiten, RaumListe, AnzRaeume) :-
        % Vorbereitungen Veranstaltungen
	findall((Name, Ressourcen), veranstaltung(Name, _, Ressourcen), 
VeranstaltungsListe),
	length(VeranstaltungsListe, AnzVeranstaltungen),
	(
	    AnzVeranstaltungen > 0
	;
	    writeln('Ein Plan ohne Veranstaltungen macht keinen Sinn.'),
	    abort
	),
        % Vorbereitungen Tage
	findall(Tage, tag(Tage, _), TagListe),
	length(TagListe, AnzTage),
	(
	    AnzTage > 0
	;
	    writeln('Ein Plan ohne Tage macht keinen Sinn.'),
	    abort
	),
        % Vorbereitungen Zeiten
	findall(Zeiten, zeit(Zeiten, _), ZeitListe),
	length(ZeitListe, AnzZeiten),
	(
	    AnzZeiten > 0
	;
	    writeln('Ein Plan ohne Zeiten macht keinen Sinn.'),
	    abort
	),	
        % Vorbereitungen Raeume
	findall(Raeume, raum(Raeume, _, _, _), RaumListe),
	length(RaumListe, AnzRaeume),
	(
	    AnzRaeume > 0
	;
	    writeln('Ein Plan ohne Raeume macht keinen Sinn.'),
	    abort
	),
	length(RaumListe, AnzRaeume).

/***********************************************************/
/* testePlatzierungsmoeglichkeiten(+AnzRaeume, +AnzZeiten, */
/*      +AnzTage, +AnzVeranstaltungen)                     */
/***********************************************************/
/* Testen, ob die Veranstaltungen in den zur Verfuegung    */
/* stehenden Zeiteinheiten platziert werden koennen        */
/***********************************************************/
testePlatzierungsmoeglichkeiten(AnzRaeume, AnzZeiten, AnzTage, AnzVeranstaltungen) :-
	writeln("    1. Testen, ob die Veranstaltungen in den zur Verfgung"),
	writeln("    stehenden Zeiteinheiten platziert werden knnen ..."),
	(
	    AnzRaeume * AnzZeiten * AnzTage >= AnzVeranstaltungen ; 
	    writeln("       Es wird versucht zu viele Veranstaltungen zu platzieren."),
	    abort
	).

/***********************************************************/
/* testeVeranstaltungsnamen(+VeranstaltungsListe)          */
/***********************************************************/
/* Testen, ob alle Veranstaltungsnamen eindeutig sind      */
/***********************************************************/
testeVeranstaltungsnamen(VeranstaltungsListe) :-
	writeln("    2. Testen, ob alle Veranstaltungsnamen eindeutig sind ..."),
	testeVeranstaltungen(VeranstaltungsListe, ErgebnisVeranst),
	(
	    (length(ErgebnisVeranst, 0),
	    writeln("       Veranstaltungsnamen - OK")) ;
	    (
		writeln("       Bitte diese Veranstaltung(en) umbenennen:"),
		flatten(ErgebnisVeranst, ErgebnisVeranstFlat),
		print_list(ErgebnisVeranstFlat),
		abort
	    )
	).

/***********************************************************/
/* testeVeranstaltungsverweise(+VeranstaltungsListe)       */
/***********************************************************/
/* Testen, ob alle weiteren Veranstaltungsverweise auf     */
/* existierende Veranstaltungen zugreifen                  */
/***********************************************************/
testeVeranstaltungsverweise(VeranstaltungsListe) :-
	writeln("    3. Testen, ob alle weiteren Veranstaltungsverweise auf"),
	writeln("    existierende Veranstaltungen zugreifen ..."),
        % hier werden doppelstunde, dreifachstunde, vierfachstunde, 
        % veranstaltung(Nicht)AmUmIn, veranstaltungen(Nicht)AmSelbenTag,
        % veranstaltungenNichtZusammenhaengend ueberprueft
	testeVeranstaltungsNamen(VeranstaltungsListe, ErgebnisVeranstNamen),
	(
	    (
		% 2 Elemente immer vorhanden
		length(ErgebnisVeranstNamen, 2),
		writeln("       Verweise - OK")
	    ) 
	;
	    (
		writeln("       Bitte diese Verweise berprfen:"),
		flatten(ErgebnisVeranstNamen, ErgebnisVeranstNamenFlat),
		print_list(ErgebnisVeranstNamenFlat),
		abort
	    )
	).

/***********************************************************/
/* testeRaumzuteilung(+RaumListe, +VeranstaltungsListe)    */
/***********************************************************/
/* Testen, ob Fehler in der Raumzuteilung existieren       */
/***********************************************************/
testeRaumzuteilung(RaumListe, VeranstaltungsListe) :-
	writeln("    4. Testen, ob Fehler in der Raumzuteilung existieren ..."),
	testeRaeume(RaumListe, VeranstaltungsListe, ErgebnisRaeume),
        % Fehlerbehandlung Raeume
        % ACHTUNG: Test auf 1, weil am Ende der Liste immer ein leeres 
	% Element haengt
	(
	    (
		length(ErgebnisRaeume, 1), 
		writeln("       Raumzuteilung - OK")
	    ) 
	;
		(
		    flatten(ErgebnisRaeume, ErgebnisRaeume1),
		    flatten(ErgebnisRaeume1, ErgebnisRaeume2),
		    writeln("       Bitte die Rume dieser Veranstaltung(en) berprfen:"),
		    print_list(ErgebnisRaeume2),
		    abort
		)
	).


/***********************************************************/
/* testeRaumzuordnungen(+VeranstaltungsListe)              */
/***********************************************************/
/* Testen, ob einer Veranstaltung Raeume anhand der        */
/* gewuenschten Ressourcen zugeordnet werden koennen       */
/***********************************************************/
testeRaumzuordnungen(VeranstaltungsListe) :-
	writeln("    5. Testen, ob einer Veranstaltung Rume anhand der"),
	writeln("    gewnschten Ressourcen zugeordnet werden knnen ..."),
	findall(RaumRessourcen, raum(_, _, RaumRessourcen, _), RessourcenListe),
	testeRaumzuordnungen(VeranstaltungsListe, RessourcenListe, ErgebnisRessourcen),
        % Fehlerbehandlung Raumzuordnung
        % ACHTUNG: Test auf 1, weil am Ende der Liste immer ein leeres 
        % Listenelement haengt
	(
	    (
		length(ErgebnisRessourcen, 1),
		writeln("       Ressourcenvergabe - OK")
	    ) 
	;
	    (
		flatten(ErgebnisRessourcen, ErgebnisRessourcen1),
		flatten(ErgebnisRessourcen1, ErgebnisRessourcen2),
		writeln("       Bitte die Ressourcen dieser Veranstaltung(en) berprfen:"),
		print_list(ErgebnisRessourcen2),
		abort
	    )
	).

/***********************************************************/
/* testeKarteileichen                                      */
/***********************************************************/
/* Testen, ob alle aufgefuehrten Teilnehmer auch           */
/* Veranstaltungsverpflichtungen besitzen                  */
/***********************************************************/
testeKarteileichen :-
	writeln("    6. Testen, ob alle aufgefhrten Teilnehmer auch"),
	writeln("    Veranstaltungsverpflichtungen besitzen ..."),
	testeAufKarteileichen(ErgebnisKarteileichen),
	(
	    (
		length(ErgebnisKarteileichen, 0),
		writeln("       Teilnehmerverweise - OK")
	    ) 
	;
	    (
		writeln("       Bitte diese Teilnehmerverweise berprfen:"),
		print_list(ErgebnisKarteileichen),
		abort
	    )
	).

/***********************************************************/
/* testeUntergruppen                                       */
/***********************************************************/
/* Testen, ob eingefuehrte Untergruppen Fehler ausloesen   */
/***********************************************************/
testeUntergruppen :-
	writeln("    7. Testen, ob eingefhrte Untergruppen Fehler auslsen ..."),
	findall(Teilnehmer, untergruppe(_, _, Teilnehmer), TeilnehmerListe),
	findall(Name, untergruppe(Name, _, _), NamensListe),
	sort(TeilnehmerListe, TeilnehmerListeSort),
	findall(Studenten, teilnehmer(Studenten, _), StudentenListe),
	findeDoppelte(NamensListe, Ergebnis1),
	ueberpruefeUntergruppen(TeilnehmerListeSort, StudentenListe, Ergebnis2),
	append(Ergebnis1, Ergebnis2, ZwErgebnis),
	flatten(ZwErgebnis, ErgebnisUntergruppen),
	(
	    (
		length(ErgebnisUntergruppen, 0),
		writeln("       Untergruppen - OK")
	    ) 
	;
	    (
		writeln("       Bitte diese Untergruppen berprfen:"),
		print_list(ErgebnisUntergruppen),
		abort
	    )
	).


/***********************************************************/
/* testeZeiteinheiten(+TagListe, +AnzTage, +AnzZeiten)     */
/***********************************************************/
/* Testen, ob alle Vorlesungen eines Teilnehmers in        */
/* den zur Verfuegung stehenden Zeiteinheiten platziert    */
/* werden koennen                                          */
/***********************************************************/
testeZeiteinheiten(TagListe, AnzTage, AnzZeiten) :-
	writeln("    8. Testen, ob alle Vorlesungen eines Teilnehmers in"),
	writeln("    den zur Verfgung stehenden Zeiteinheiten platziert"),
	writeln("    werden knnen..."),
	testeZeiteinheiten(TagListe, AnzTage, AnzZeiten, ErgebnisZeiteinheiten),
	(
	    (
		length(ErgebnisZeiteinheiten, 0),
		writeln("       Keine Platzierungsprobleme - OK")
	    ) 
	;
	    (
		writeln("       Bitte diese Einschrnkung(en) berprfen:"),
		print_list(ErgebnisZeiteinheiten),
		abort
	    )
	).


/***********************************************************/
/* testeHarteConstraints                                   */
/***********************************************************/
/* Testen, ob sich ausschliessende harte Einschraenkungen  */
/* existieren                                              */
/***********************************************************/
testeHarteConstraints :-
	writeln("    9. Testen, ob sich ausschlieende harte"),
	writeln("    Einschrnkungen existieren ..."),
	findeSichAusschliessendeAnforderungen(ErgebnisAnforderungen),
%	testeVeranstaltungsplatzierungen(ErgebnisPlatzierungen),
	append(ErgebnisAnforderungen, ErgebnisPlatzierungen, Ergebnis),	
	(
	    (
		% Es sind immer zwei (Steuerungs-)Elemente vorhanden
%		length(Ergebnis, 3),
		length(Ergebnis, 2),
		writeln("       Keine Probleme - OK")
	    ) 
	;
	    (
		writeln("       Bitte diese Einschrnkung(en) berprfen:"),
		print_list(Ergebnis),
		abort
	    )
	).
        
/***********************************************************/
/* testeVeranstatlungen(+Veranstaltungen, -Ergebnis)       */
/***********************************************************/
/* Testen, ob alle Veranstaltungen eindeutige Namen haben. */
/***********************************************************/
testeVeranstaltungen([], []).
testeVeranstaltungen(VeranstaltungsListe, []) :-
	length(VeranstaltungsListe, N),
	sort(VeranstaltungsListe, VeranstaltungsListeSort),
	length(VeranstaltungsListeSort, M),
	N == M.
testeVeranstaltungen([Kopf|VeranstaltungsListe], Ergebnis) :-
	nonmember(Kopf, VeranstaltungsListe),
	testeVeranstaltungen(VeranstaltungsListe, Ergebnis).
testeVeranstaltungen([(Name, Ressourcen)|VeranstaltungsListe], [ErgebnisKopf|ErgebnisRest]) :-
	member((Name, Ressourcen), VeranstaltungsListe),
	append([Name], [], ErgebnisKopf),
	testeVeranstaltungen(VeranstaltungsListe, ErgebnisRest).

/***********************************************************/
/* testeMehrfachstunden(+Veranstaltungen, -Ergebnis)       */
/***********************************************************/
/* Testen, ob alle Mehrfachstunden auf wirkliche           */
/* Veranstaltungen zurueck gehen und keine Stunde doppelt  */
/* aufgefuehrt wird,                                       */
/* Wuensche bleiben dabei unberuecksichtigt.               */
/***********************************************************/
testeVeranstaltungsNamen(VeranstaltungsListe, Ergebnis) :-
	findeDoppelstunden(DoppelstundenListe),
	findeDreifachstunden(DreifachstundenListe),
	findeVierfachstunden(VierfachstundenListe),
        % Zusammenfuehren der Listen
	append(DoppelstundenListe, DreifachstundenListe, Liste),
	append(Liste, VierfachstundenListe, MehrfachstundenListe),
        % Vorbereitung weiterer VeranstaltungsNamen
	findall(Veranstaltung, veranstaltungAmUmIn(Veranstaltung, _, _, _), 
AmUmInListe),
	findall(Veranstaltung, veranstaltungNichtAmUmIn(Veranstaltung, _, _, _), 
NichtAmUmInListe),
	findall(Veranstaltung, veranstaltungenNichtZusammenhaengend(Veranstaltung, _), VeranstaltungsListe3),
	findall(Veranstaltung, veranstaltungenNichtZusammenhaengend(_, Veranstaltung), VeranstaltungsListe4),
	append(VeranstaltungsListe3, VeranstaltungsListe4, NichtZusammenhaengendListe),

        % Vorbereitung veranstaltungenAmSelbenTag (/2, /3, /4)
	findeVeranstaltungenAmSelbenTagOhneWuensche(AmSelbenTagListe),
	findeVeranstaltungenNichtAmSelbenTagOhneWuensche(NichtAmSelbenTagListe),

        % Zusammenfuehren der Listen
	append(AmUmInListe, NichtAmUmInListe, HilfsListe15),
	append(HilfsListe15, NichtZusammenhaengendListe, HilfsListe16),
	append(HilfsListe16, AmSelbenTagListe, HilfsListe17),
	append(HilfsListe17, NichtAmSelbenTagListe, VeranstaltungsListeFinal),
	findeDoppelte(AmUmInListe, Ergebnis1),
	findeDoppelte(NichtAmUmInListe, Ergebnis2),
	findeDoppelte(AmSelbenTagListe, Ergebnis3),
	findeDoppelte(NichtAmSelbenTagListe, Ergebnis4),
	findeDoppelte(DoppelstundenListe, Ergebnis5),
	findeDoppelte(DreifachstundenListe, Ergebnis6),
	findeDoppelte(VierfachstundenListe, Ergebnis7),
	findeBlindgaenger(VeranstaltungsListeFinal, VeranstaltungsListe, Ergebnis8),
	findeBlindgaenger(MehrfachstundenListe, VeranstaltungsListe, Ergebnis9),
	append(['Doppelt vorkommende Namen:'], Ergebnis1, HilfsErgebnis1),
	append(HilfsErgebnis1, Ergebnis2, HilfsErgebnis2),
	append(HilfsErgebnis2, Ergebnis3, HilfsErgebnis3),
	append(HilfsErgebnis3, Ergebnis4, HilfsErgebnis4),
	append(HilfsErgebnis4, Ergebnis5, HilfsErgebnis5),
	append(HilfsErgebnis5, Ergebnis6, HilfsErgebnis6),
	append(HilfsErgebnis6, Ergebnis7, HilfsErgebnis7),
	append(HilfsErgebnis7, ['Fehlerhafte Namen:'], HilfsErgebnis8),
	append(HilfsErgebnis8, Ergebnis8, HilfsErgebnis9),
	append(HilfsErgebnis9, Ergebnis9, Ergebnis).

/***********************************************************/
/* findeBlindgaenger(+MehrfachVeranstaltungen,             */
/*     +Veranstaltungen, -Ergebnis)                        */
/***********************************************************/
/* Testen, ob alle Stunden auf Namen in der                */
/* Wissensbasis zurueckgehen                               */
/***********************************************************/
findeBlindgaenger([], _, []).
findeBlindgaenger([MehrfachKopf|MehrfachRest], VeranstaltungsListe, ErgebnisListe) :-
	member((MehrfachKopf, _), VeranstaltungsListe),
	findeBlindgaenger(MehrfachRest, VeranstaltungsListe, ErgebnisListe).
findeBlindgaenger([MehrfachKopf|MehrfachRest], VeranstaltungsListe, [ErgebnisKopf|ErgebnisRest]) :-
	nonmember((MehrfachKopf, _), VeranstaltungsListe),
	append([MehrfachKopf], [], ErgebnisKopf),
	findeBlindgaenger(MehrfachRest, VeranstaltungsListe, ErgebnisRest).

/***********************************************************/
/* testeRaeume(+RaumListe, +VeranstaltungsListe,           */
/*     -Ergebnis)                                          */
/***********************************************************/
/* Testen, ob nicht zufaellig mehrere Raeume (nicht ueber  */
/* oder(_) verbunden) einer Veranstaltung zugeordnet sind. */
/***********************************************************/
testeRaeume(_, [], []).
testeRaeume(RaumListe, [VeranstKopf|VeranstaltungsListe], [ErgebnisKopf|Ergebnis]) :-
	einRaumVorhanden(RaumListe, VeranstKopf, ErgebnisKopf),
	((length(ErgebnisKopf, 0), testeRaeume(RaumListe, VeranstaltungsListe, [ErgebnisKopf|Ergebnis])) ; 
	testeRaeume(RaumListe, VeranstaltungsListe, Ergebnis)).

/***********************************************************/
/* einRaumVorhanden(+RaumListe, +Veranstaltung,            */
/*     -Ergebnis)                                          */
/***********************************************************/
einRaumVorhanden([], _, _).
einRaumVorhanden(RaumListe, (VerName, Ressourcen), Ergebnis) :-
	member(oder(Raeume), Ressourcen),
	istTeilmenge(Raeume, RaumListe),
	nochEinRaumVorhanden(RaumListe, (VerName, Ressourcen), Ergebnis).
einRaumVorhanden([RaumKopf|RaumListe], (VerName, Ressourcen), Ergebnis) :-
	nonmember(RaumKopf, Ressourcen),
	einRaumVorhanden(RaumListe, (VerName, Ressourcen), Ergebnis).
einRaumVorhanden([RaumKopf|RaumListe], (VerName, Ressourcen), Ergebnis) :-
	member(RaumKopf, Ressourcen),
	nochEinRaumVorhanden(RaumListe, (VerName, Ressourcen), Ergebnis).

/***********************************************************/
/* nochEinRaumVorhanden(+RaumListe, +Veranstaltung,        */
/*     -Ergebnis)                                          */
/***********************************************************/
nochEinRaumVorhanden([], _, []).
nochEinRaumVorhanden([RaumKopf|RaumListe], (Name, Ressourcen), Ergebnis) :-
	nonmember(RaumKopf, Ressourcen),
	nochEinRaumVorhanden(RaumListe, (Name, Ressourcen), Ergebnis).
nochEinRaumVorhanden([RaumKopf|_], (Name, Ressourcen), Ergebnis) :-
	member(RaumKopf, Ressourcen),
	append([Name], [], Ergebnis),
	einRaumVorhanden([], _, Ergebnis).

/***********************************************************/
/* testeRaumzuordnungen(+Veranstaltungen, +RaumListe,      */
/*     -Ergebnis)                                          */ 
/***********************************************************/
/* Testen, ob einer Veranstaltung mind. 1 Raum zugeordnet  */
/* werden kann                                             */
/***********************************************************/
testeRaumzuordnungen([], _, []).
testeRaumzuordnungen([(Name, Ressourcen)|VeranstaltungsListe], RaumListe, 
	[ErgebnisKopf|Ergebnis]) :-
	findeRaumzuordnungen((Name, Ressourcen), RaumListe, ErgebnisKopf),
	((length(ErgebnisKopf, 0), testeRaumzuordnungen(VeranstaltungsListe, 
	RaumListe, [ErgebnisKopf|Ergebnis])) ; 
	testeRaumzuordnungen(VeranstaltungsListe, RaumListe, Ergebnis)).

/***********************************************************/
/* findeRaumzuordnungen(+Veranstaltung, +RaumListe,        */
/*     -Ergebnis)                                          */ 
/***********************************************************/
findeRaumzuordnungen((Name, _), [], Ergebnis) :-
	append([Name], [], Ergebnis).
findeRaumzuordnungen((_, Ressourcen), RaumListe, _) :-
	member(oder(Raeume), Ressourcen),
	istTeilmenge(Raeume, RaumListe).
findeRaumzuordnungen((Name, Ressourcen), RaumListe, Ergebnis) :-
	member(oder(Raeume), Ressourcen),
	not(istTeilmenge(Raeume, RaumListe)),
	delete(oder(Raeume), Ressourcen, RessourcenDel),
	findeRaumzuordnungen((Name, RessourcenDel), RaumListe, Ergebnis).
findeRaumzuordnungen((_, Ressourcen), RaumListe, _) :-
        member(und(Raeume), Ressourcen),
        istTeilmenge(Raeume, RaumListe).
findeRaumzuordnungen((Name, Ressourcen), RaumListe, Ergebnis) :-
        member(und(Raeume), Ressourcen),
        not(istTeilmenge(Raeume, RaumListe)),
       	delete(und(Raeume), Ressourcen, RessourcenDel),
	findeRaumzuordnungen((Name, RessourcenDel), RaumListe, Ergebnis).
findeRaumzuordnungen((_, Ressourcen), [RaumKopf|_], _) :-
	istTeilmenge(Ressourcen, RaumKopf).
findeRaumzuordnungen((Name, Ressourcen), [RaumKopf|RaumRessourcenListe], Ergebnis) :-
	not(istTeilmenge(Ressourcen, RaumKopf)),
	findeRaumzuordnungen((Name, Ressourcen), RaumRessourcenListe, Ergebnis).

/***********************************************************/
/* testeAufKarteileichen(+Studenten, +Dozenten, -Ergebnis) */ 
/***********************************************************/
/* Testen, ob sich Teilnehmer in der Wissensbasis befinden,*/
/* die nicht an Veranstaltungen teilnehmen (Rechenzeit).   */
/***********************************************************/
testeAufKarteileichen(Ergebnis) :-
	findall(Studenten, teilnehmer(Studenten, _), StudentenListe1),
	dozenten(DozentenListe),
	findall(Untergruppen, untergruppe(Untergruppen, _, _), UntergruppenListe),
	findall(Teilnehmer, veranstaltung(_, Teilnehmer, _), VeranstaltungsTeilnehmerListe),
	flatten(VeranstaltungsTeilnehmerListe, VeranstaltungsTeilnehmerFlat),
	sort(VeranstaltungsTeilnehmerFlat, VeranstaltungsTeilnehmerSort),
	append(StudentenListe1, UntergruppenListe, StudentenListe),
	append(StudentenListe, DozentenListe, TeilnehmerListe),
	(
	    length(TeilnehmerListe, N),
	    N > 0
	;
	    writeln('Ein Plan ohne Teilnehmer macht keinen Sinn.'),
	    abort
	),
	subtract(VeranstaltungsTeilnehmerSort, TeilnehmerListe, Ergebnis).

/***********************************************************/
/* ueberpruefeUntergruppen(+Teilnehmer, +Studenten,        */
/*     -Ergebnis)                                          */
/***********************************************************/
ueberpruefeUntergruppen(TeilnehmerListe, StudentenListe, Ergebnis) :- 
	subtract(TeilnehmerListe, StudentenListe, Ergebnis).

/***********************************************************/
/* testeZeiteinheiten(-Ergebnis)                           */
/***********************************************************/
/* Testen, ob die Veranstaltungsteilnehmer bei gegebenen   */
/* harten Einschraenkungen ueberhaupt in der Lage sind,    */
/* den Teilnahmeverpflichtungen nachzukommen.              */
/* Dazu werden die Einschraenkungen teilnehmerNichtAmUm    */
/* eingelesen.  Hieraus werden die Teilnehmer              */
/* herausgefiltert, die mehrfach auftreten und bei denen   */
/* Tage durch einen Unterstrich (alle moeglichen Tage)     */
/* gekennzeichnet sind.  Bei diesen Teilnehmern werden die */
/* Tage ergaenzt, so dass                                  */
/* teilnehmerNichtAmUm(xyz, _, ['8:00']).                  */
/* teilnehmerNichtAmUm(xyz, ['Montag'], _).                */
/* zu                                                      */
/* teilnehmerNichtAmUm(xyz, ['Dienstag', 'Mittwoch',       */
/*     'Donnerstag', 'Freitag', 'Samstag'], ['8:00']).     */
/* teilnehmerNichtAmUm(xyz, ['Montag'], _).                */
/* wird.                                                   */
/***********************************************************/
testeZeiteinheiten(TagListe, AnzTage, AnzZeiten, Ergebnis) :-
	findall(Teilnehmer, teilnehmerNichtAmUm(Teilnehmer, _, _), TeilnehmerListe),
	sort(TeilnehmerListe, TeilnehmerListeSort),
	findeMehrfachAufgefuehrte(TeilnehmerListeSort, MehrfachListe),
	erweitereListeUmTage(MehrfachListe, TagListe, NeueTagListe),
	schreibeTage(MehrfachListe, NeueTagListe, NeueMehrfachListe),
	flatten(NeueMehrfachListe, NeueMehrfachListeFlat),
	findall((Teilnehmer, Am, Um), (teilnehmerNichtAmUm(Teilnehmer, Am, Um), nonmember((Teilnehmer, _, _), NeueMehrfachListeFlat)), NeueTeilnehmerListe),
	append(NeueTeilnehmerListe, NeueMehrfachListeFlat, VollstaendigeTeilnehmerListe),
	sort(VollstaendigeTeilnehmerListe, VollstaendigeTeilnehmerListeSort),
	berechneZurVerfuegungStehendeZeiteinheiten(VollstaendigeTeilnehmerListeSort, AnzTage, AnzZeiten, ErgebnisListe),
	flatten(ErgebnisListe, ErgebnisListeFlat),
	fuehreErgebnisseZusammen(ErgebnisListeFlat, ErgebnisListeKomprimiert),
	flatten(ErgebnisListeKomprimiert, ErgebnisListeKomprimiertFlat),
	AnzZeitenUndTage is AnzTage * AnzZeiten,
	berechneVeranstaltungenDerTeilnehmer(ErgebnisListeKomprimiertFlat, AnzZeitenUndTage, TeilnehmerErgebnis),
	flatten(TeilnehmerErgebnis, Ergebnis).

/***********************************************************/
/* findeSichAusschliessendeAnforderungen(-Ergebnis)        */
/***********************************************************/
/* Findet einfach aufzuspurende sich gegenseitig           */
/* ausschliessende Veranstaltungen in                      */
/* veranstaltung(Nicht)AmSelbenTag (im Moment nicht),      */
/* veranstlatung(Nicht)AmUmIn,                             */
/* Mehrfachstunden und                                     */
/* veranstaltungenNichtZusammenhaengend.                   */
/***********************************************************/
findeSichAusschliessendeAnforderungen(Ergebnis) :-
%	findeFehlerInVeranstaltungenAmSelbenTag(ErgebnisAmSelbenTag),
	findeFehlerInVeranstaltungAmUmIn(ErgebnisAmUmIn),
	findeFehlerInDoppelstundeNichtZusammenhaengend(ErgebnisNichtZusammenhaengend),
%	append(['veranstaltung(Nicht)AmSelbenTag:'], ErgebnisAmSelbenTag, HilfsListe1),
	append(['veranstaltung(Nicht)AmUmIn:'], ErgebnisAmUmIn, HilfsListe2),
	append(['veranstaltungNichtZusammenhaengend/doppelstunde usw.:'], ErgebnisNichtZusammenhaengend, HilfsListe3),
	append(HilfsListe1, HilfsListe2, ZwErgebnis1),
	append(ZwErgebnis1, HilfsListe3, ZwErgebnis2),
	flatten(ZwErgebnis2, Ergebnis).

/***********************************************************/
/* findeFehlerInVeranstaltungenAmSelbenTag(-Ergebnis)      */
/***********************************************************/
/* veranstaltung(Nicht)AmSelbenTag                         */
/* Wuensche bleiben unbercksichtigt.                      */
/***********************************************************/
findeFehlerInVeranstaltungenAmSelbenTag(_):-
	findeVeranstaltungenAmSelbenTagOhneWuensche(AmSelbenTagOhneWuensche),
	findeVeranstaltungenNichtAmSelbenTagOhneWuensche(NichtAmSelbenTagOhneWuensche),
	append(AmSelbenTagOhneWuensche, NichtAmSelbenTagOhneWuensche, Liste),
	sort(Liste, ListeSort), 
	length(Liste, N),
	length(ListeSort, M),
	M = N.
findeFehlerInVeranstaltungenAmSelbenTag(Ergebnis):-
	findeVeranstaltungenAmSelbenTagOhneWuensche(AmSelbenTagOhneWuensche),
	findeVeranstaltungenNichtAmSelbenTagOhneWuensche(NichtAmSelbenTagOhneWuensche),
	append(AmSelbenTagOhneWuensche, NichtAmSelbenTagOhneWuensche, Liste),
	findeDoppelte(Liste, ZwErgebnis),
	flatten(ZwErgebnis, Ergebnis).

/***********************************************************/
/* findeFehlerInVeranstaltungenAmUmIn(-Ergebnis)           */
/***********************************************************/
/* veranstaltung(Nicht)AmUmIn                              */
/* Wuensche bleiben unbercksichtigt.                      */
/***********************************************************/
findeFehlerInVeranstaltungAmUmIn(_) :-
	findall(Name, veranstaltungAmUmIn(Name, _, _, _), Liste1),
	findall(Name, veranstaltungNichtAmUmIn(Name, _, _, _), Liste2),
	append(Liste1, Liste2, AmUmInListe),
	sort(AmUmInListe, AmUmInListeSort),
	length(AmUmInListe, N), 
	length(AmUmInListeSort, M),
	M = N.
findeFehlerInVeranstaltungAmUmIn(Ergebnis) :-
	findall(Name, veranstaltungAmUmIn(Name, _, _, _), Liste1),
	findall(Name, veranstaltungNichtAmUmIn(Name, _, _, _), Liste2),
	append(Liste1, Liste2, AmUmInListe),
	findeDoppelte(AmUmInListe, ZwErgebnis),
	flatten(ZwErgebnis, Ergebnis).

/***********************************************************/
/* findeFehlerInDoppelstundeNichtZusammenhaengend(         */
/*     -Ergebnis)                                          */
/***********************************************************/
/* Mehrfachstunden und veranstaltung(Nicht)AmSelbenTag     */
/* Wuensche bleiben unbercksichtigt.                      */
/***********************************************************/
findeFehlerInDoppelstundeNichtZusammenhaengend(Ergebnis) :-
	% nicht findeXXXstunden, weil eine andere Ergebnisformatierung benoetigt wird
	findall((Name1, Name2), doppelstunde(Name1, Name2), Liste1),
	findall((Name1, Name2, Name3), dreifachstunde(Name1, Name2, Name3), Liste2),
	findall((Name1, Name2, Name3, Name4), vierfachstunde(Name1, Name2, Name3, Name4), Liste3),
	findall((Name1, Name2), veranstaltungenNichtAmSelbenTag(Name1, Name2), Liste4),
	findall((Name1, Name2), veranstaltungenNichtZusammenhaengend(Name1, Name2), NichtZusammenhaengendListe),
	append(Liste1, Liste2, HilfsListe1),
	append(HilfsListe1, Liste3, HilfsListe2),
	append(HilfsListe2, Liste4, MehrfachstundenListe),
	append(MehrfachstundenListe, NichtZusammenhaengendListe, MehrfachNichtZusammenhaengendListe),
	findeDoppelte(MehrfachNichtZusammenhaengendListe, ZwErgebnis),
	flatten(ZwErgebnis, Ergebnis).
	
/***********************************************************/
/* testeVeranstaltungsplatzierungen(-Ergebnis)             */
/***********************************************************/
testeVeranstaltungsplatzierungen(Ergebnis) :-
	findall(Teilnehmer, (veranstaltungAmUmIn(Name, _, _, _), veranstaltung(Name, Teilnehmer, _)), TeilnehmerListe),
	flatten(TeilnehmerListe, TeilnehmerListeFlat),
	sort(TeilnehmerListeFlat, TeilnehmerListeSort),
	findeVeranstaltungenDerTeilnehmerAnEinemTag(TeilnehmerListeSort, VeranstListe),
	flatten(VeranstListe, VeranstListeFlat),
	sort(VeranstListeFlat, Ergebnis).

/***********************************************************/
/* findeVeranstaltungenDerTeilnehmerAnEinemTag(            */
/*     +TeilnehmerListe, -Ergebnis)                        */
/***********************************************************/
/* Findet, die Veranstaltungen eines Teilnehmer, wo        */
/* mindestens 2 an einem Tag stattfinden.                  */
/* Gibt nur die Veranstaltungen aus, die an einem Tag      */
/* stattfinden.                                            */
/***********************************************************/
findeVeranstaltungenDerTeilnehmerAnEinemTag([], []).
findeVeranstaltungenDerTeilnehmerAnEinemTag([Kopf|Rest], Ergebnis) :-
        % Vorbereiten einer TagesListe
	findall(Tage, (veranstaltungAmUmIn(Name, Tage, _, _), veranstaltung(Name, Teilnehmer, _), member(Kopf, Teilnehmer)), TagListe),
	findeDoppelte(TagListe, TagListe1),
	flatten(TagListe1, TagListe2),
	flatten(TagListe2, RelevanteTage),
        % Vorbereiten einer ZeitenListe
	findall(Zeiten, (veranstaltungAmUmIn(Name, Tage, Zeiten, _), veranstaltung(Name, Teilnehmer, _), member(Kopf, Teilnehmer), istTeilmenge(Tage, RelevanteTage)), ZeitListe),
	flatten(ZeitListe, ZeitListeFlat),
	findeDoppelte(ZeitListeFlat, ZeitListe1),
	flatten(ZeitListe1, ZeitListe2),
	flatten(ZeitListe2, RelevanteZeiten),
        % eigentliche Abfrage
	findall((Name, Kopf, Tage, Zeiten), (veranstaltungAmUmIn(Name, Tage, Zeiten, _), veranstaltung(Name, Teilnehmer, _), member(Kopf, Teilnehmer), istTeilmenge(Tage, RelevanteTage), istTeilmenge(Zeiten, RelevanteZeiten)), ErgebnisKopf),
 	writeln(ErgebnisKopf),
	length(ErgebnisKopf, N),
	N < 2,
	findeVeranstaltungenDerTeilnehmerAnEinemTag(Rest, Ergebnis).
findeVeranstaltungenDerTeilnehmerAnEinemTag([Kopf|Rest], [ErgebnisKopf|ErgebnisRest]) :-
        % Vorbereiten einer TagesListe
	findall(Tage, (veranstaltungAmUmIn(Name, Tage, _, _), veranstaltung(Name, Teilnehmer, _), member(Kopf, Teilnehmer)), TagListe),
	findeDoppelte(TagListe, TagListe1),
	flatten(TagListe1, TagListe2),
	flatten(TagListe2, RelevanteTage),
        % Vorbereiten einer ZeitenListe
	findall(Zeiten, (veranstaltungAmUmIn(Name, Tage, Zeiten, _), veranstaltung(Name, Teilnehmer, _), member(Kopf, Teilnehmer), istTeilmenge(Tage, RelevanteTage)), ZeitListe),
	flatten(ZeitListe, ZeitListeFlat),
	findeDoppelte(ZeitListeFlat, ZeitListe1),
	flatten(ZeitListe1, ZeitListe2),
	flatten(ZeitListe2, RelevanteZeiten),
        % eigentliche Abfrage
	findall((Name, Kopf, Tage, Zeiten), (veranstaltungAmUmIn(Name, Tage, Zeiten, _), veranstaltung(Name, Teilnehmer, _), member(Kopf, Teilnehmer), istTeilmenge(Tage, RelevanteTage), istTeilmenge(Zeiten, RelevanteZeiten)), ErgebnisKopf),
	findeVeranstaltungenDerTeilnehmerAnEinemTag(Rest, ErgebnisRest).


